package access;


import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Vector;
import java.io.File;

import business.ProgramHandler;

public class RegisteredProgramsDB implements DatabaseConstants
{
  public RegisteredProgramsDB()
  {

  }

  public boolean storeProgramHandler(String sProgramName, ProgramHandler objPH)
  {
        Database objDB = new Database();
        try
        {
            objDB.writeObject(LISTENER_PROGRAMS+sProgramName+LISTENER_PROGRAMS_FILE_EXTENSION, objPH);
        }
        catch(Exception e)
        {
            return false;
        }

        return true;

  }

  public ProgramHandler retrieveProgramHandler(String sProgramName)
  {

      Database objDB = new Database();
      try
      {
          ProgramHandler objPH = null;
          objPH = (ProgramHandler)objDB.readObject(LISTENER_PROGRAMS+sProgramName+LISTENER_PROGRAMS_FILE_EXTENSION);
          //System.out.println("PH ++*****"+objPH);
          return objPH;
      }
      catch(Exception e)
      {
            //System.out.println("PRH %*(^(^(^");
          //e.printStackTrace();
          System.out.println("Exception occured while retrieving Program Handlers for Program : " + sProgramName);
          return null;
      }
  }


    public boolean removeProgramHandler(String sProgramName)
    {
        File fProgramHandler = new File(LISTENER_PROGRAMS + sProgramName + LISTENER_PROGRAMS_FILE_EXTENSION);

        return (fProgramHandler.delete());

    }

    public boolean storeProgramNames(Hashtable htProgramName)
  {

      Enumeration objKeys = htProgramName.keys();
      Vector vProgramNames = new Vector();

      while(objKeys.hasMoreElements()==true)
      {
           vProgramNames.add(objKeys.nextElement());
      }


      Database objDB = new Database();
      try
      {
         objDB.writeObject(PROGRAMS_LIST+PROGRAMS_LIST_FILE_EXTENSION, vProgramNames);
      }
      catch(Exception e)
      {
        return false;
      }
      return true;
  }

  public Vector retrieveProgramNames()
  {
   Database objDB = new Database();
      try
      {
        return ((Vector) objDB.readObject(PROGRAMS_LIST+PROGRAMS_LIST_FILE_EXTENSION));
      }
      catch(NullPointerException npe)
      {
        return null;
      }
  }

    public boolean removeProgramList()
    {
      File fRecordedProgramList = new File(PROGRAMS_LIST+ PROGRAMS_LIST_FILE_EXTENSION);
        return (fRecordedProgramList.delete());
    }

    public boolean removeRecordedProgramlist()
    {
       File fRecordedRecordedProgramList = new File(RECORDED_PROGRAMS_LIST +  RECORDED_PROGRAMS_LIST_FILE_EXTENSION);
        return (fRecordedRecordedProgramList.delete());
    }



    public boolean removeRecordedProgram(String sProgramName)
    {
        File fRecordedProgram = new File(RECORDED_PROGRAM + sProgramName + RECORDED_PROGRAM_FILE_EXTENSION);
        return (fRecordedProgram.delete());
    }
}