package view;

import javax.swing.*;
import javax.swing.table.TableCellEditor;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.*;

/** Table cell editor that uses a JSlider. */

  public class NoteCellEdit extends AbstractCellEditor implements TableCellEditor

  {
   private int iRow;
    public NoteCellEdit()

    {

      slider = new JSlider(JSlider.HORIZONTAL, 0, 127, 0);

      slider.addMouseListener(new MouseAdapter()

      {

        public void mouseReleased(MouseEvent event)

        {

          stopCellEditing();

        }

      });

    }

     public int getSelectedRow()
     {
         return iRow;
     }
    public Component getTableCellEditorComponent(JTable table, Object value, boolean selected, int row, int column)

    {
      iRow=row;
      slider.setBounds(table.getCellRect(row, column, false));

      slider.updateUI();

      slider.setValue(((Integer) value).intValue());

      return slider;

    }


    public Object getCellEditorValue()

    {

      return new Integer(slider.getValue());

    }


    private JSlider slider;

    private boolean firstTime = true;

  }


